﻿using System;
using System.Collections.Generic;
using System.Net.Mail;
using System.Text;
using BigfootWeb.Email;
using DotNetNuke.Common;
using DotNetNuke.Services.Mail;
using MailPriority = DotNetNuke.Services.Mail.MailPriority;

namespace BigfootDNN
{
    class DnnEmailProvider : IEmailProvider 
    {
        
        public void SendEmail(MailMessage msg)
        {
             SendEmail(msg, null);
        }

        public void SendEmail(MailMessage msg, params string[] attachments)
        {
            var priority = msg.Priority == System.Net.Mail.MailPriority.High
                                ? MailPriority.High
                                : (msg.Priority == System.Net.Mail.MailPriority.Low
                                        ? MailPriority.Low
                                        : MailPriority.Normal);
            var from = msg.From.Address;
            var to = msg.To.ToString();
            var cc = msg.CC.ToString();
            var bcc = msg.Bcc.ToString();
            var subject = msg.Subject;
            var bodyFormat = msg.IsBodyHtml ? MailFormat.Html : MailFormat.Text;
            var encoding = msg.BodyEncoding;
            var body = msg.Body;
            
            var SMTPServer = Convert.ToString(Globals.GetPortalSettings().HostSettings["SMTPServer"]);
            var SMTPAuthentication = Convert.ToString(Globals.GetPortalSettings().HostSettings["SMTPAuthentication"]);
            var SMTPUsername = Convert.ToString(Globals.GetPortalSettings().HostSettings["SMTPUsername"]);
            var SMTPPassword = Convert.ToString(Globals.GetPortalSettings().HostSettings["SMTPPassword"]);
            var SMTPEnableSSL = Convert.ToBoolean(Globals.GetPortalSettings().HostSettings["SMTPEnableSSL"]);
            

            Mail.SendMail(from, to, cc, bcc, priority, subject, bodyFormat, encoding, body, attachments, 
                            SMTPServer, SMTPAuthentication, SMTPUsername, SMTPPassword, SMTPEnableSSL);
        }
    }
}
